---
title: URLSearchParams
slug: Web/API/URLSearchParams
tags:
  - API
  - Interface
  - Landing
  - Reference
  - URL API
  - URLSearchParams
---
<div>{{ApiRef("URL API")}}</div>

<p>The <strong><code>URLSearchParams</code></strong> interface defines utility methods to work with the query string of a URL.</p>

<p>An object implementing <code>URLSearchParams</code> can directly be used in a {{jsxref("Statements/for...of", "for...of")}} structure, for example the following two lines are equivalent:</p>

<pre class="brush: js">for (const [key, value] of mySearchParams) {}
for (const [key, value] of mySearchParams.entries()) {}</pre>

<p>{{availableinworkers}}</p>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dt>{{domxref("URLSearchParams.URLSearchParams", 'URLSearchParams()')}}</dt>
 <dd>Returns a <code>URLSearchParams</code> object instance.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<dl>
 <dt>{{domxref("URLSearchParams.append()")}}</dt>
 <dd>Appends a specified key/value pair as a new search parameter.</dd>
 <dt>{{domxref("URLSearchParams.delete()")}}</dt>
 <dd>Deletes the given search parameter, and its associated value, from the list of all search parameters.</dd>
 <dt>{{domxref("URLSearchParams.entries()")}}</dt>
 <dd>Returns an {{jsxref("Iteration_protocols","iterator")}} allowing iteration through all key/value pairs contained in this object.</dd>
 <dt>{{domxref("URLSearchParams.forEach()")}}</dt>
 <dd>Allows iteration through all values contained in this object via a callback function.</dd>
 <dt>{{domxref("URLSearchParams.get()")}}</dt>
 <dd>Returns the first value associated with the given search parameter.</dd>
 <dt>{{domxref("URLSearchParams.getAll()")}}</dt>
 <dd>Returns all the values associated with a given search parameter.</dd>
 <dt>{{domxref("URLSearchParams.has()")}}</dt>
 <dd>Returns a {{jsxref("Boolean")}} indicating if such a given parameter exists.</dd>
 <dt>{{domxref("URLSearchParams.keys()")}}</dt>
 <dd>Returns an {{jsxref("Iteration_protocols", "iterator")}} allowing iteration through all keys<strong> </strong>of the key/value pairs contained in this object.</dd>
 <dt>{{domxref("URLSearchParams.set()")}}</dt>
 <dd>Sets the value associated with a given search parameter to the given value. If there are several values, the others are deleted.</dd>
 <dt>{{domxref("URLSearchParams.sort()")}}</dt>
 <dd>Sorts all key/value pairs, if any, by their keys.</dd>
 <dt>{{domxref("URLSearchParams.toString()")}}</dt>
 <dd>Returns a string containing a query string suitable for use in a URL.</dd>
 <dt>{{domxref("URLSearchParams.values()")}}</dt>
 <dd>Returns an {{jsxref("Iteration_protocols", "iterator")}} allowing iteration through all values<strong> </strong>of the key/value pairs contained in this object.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<pre class="brush: js">var paramsString = "q=URLUtils.searchParams&amp;topic=api";
var searchParams = new URLSearchParams(paramsString);

//Iterate the search parameters.
for (let p of searchParams) {
  console.log(p);
}

searchParams.has("topic") === true; // true
searchParams.get("topic") === "api"; // true
searchParams.getAll("topic"); // ["api"]
searchParams.get("foo") === null; // true
searchParams.append("topic", "webdev");
searchParams.toString(); // "q=URLUtils.searchParams&amp;topic=api&amp;topic=webdev"
searchParams.set("topic", "More webdev");
searchParams.toString(); // "q=URLUtils.searchParams&amp;topic=More+webdev"
searchParams.delete("topic");
searchParams.toString(); // "q=URLUtils.searchParams"
</pre>

<h3 id="Gotchas">Gotchas</h3>

<p>The <code>URLSearchParams</code> constructor does <em>not</em> parse full URLs. However, it will strip an initial leading <code>?</code> off of a string, if present.</p>

<pre class="brush: js">var paramsString1 = "http://example.com/search?query=%40";
var searchParams1 = new URLSearchParams(paramsString1);

searchParams1.has("query"); // false
searchParams1.has("http://example.com/search?query"); // true

searchParams1.get("query"); // null
searchParams1.get("http://example.com/search?query"); // "@" (equivalent to decodeURIComponent('%40'))

var paramsString2 = "?query=value";
var searchParams2 = new URLSearchParams(paramsString2);
searchParams2.has("query"); // true

var url = new URL("http://example.com/search?query=%40");
var searchParams3 = new URLSearchParams(url.search);
searchParams3.has("query") // true
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('URL', '#urlsearchparams', "URLSearchParams")}}</td>
   <td>{{Spec2('URL')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.URLSearchParams")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>The {{domxref("URL")}} interface.</li>
 <li><a href="https://developers.google.com/web/updates/2016/01/urlsearchparams?hl=en">Google Developers: Easy URL manipulation with URLSearchParams</a></li>
</ul>
